Level2:
	initobj
	jsr		InitHarrier
	move.l		HarrLoc,a5
	move.l		#0,JumpKeys	;clear the codes for the "Jump Keys"
	move.l		#0,JumpKeys+4
	move.l		#7,d0
	jsr		InitLavaSpitter
	move.l		#15,d0
	jsr		InitMini
	move.l		#8,d0
	jsr		InitTank
	move.l		#30,d0
	jsr		InitPalm
	move.l		#8,d0
	jsr		InitTanker
	jsr		InitBase

	addobj		Level2Objectives,NopExe,#-50*ScreenRatio,#0,#0,#0,0,0,#0,#0,#0,#0,#0,#0

	move.l		a6,ObjectiveLoc


	move.l		#L2_StartLevelScript,CurrLevelStartScript
	move.l		CurrLevelStartScript,a0
	jsr		(a0)
	rts



Level2Objectives:
	move.l		#-50*ScreenRatio,8(a5)
	cmp.l		#1,24(a5)
	beq		L2ObjectiveMet
	cmp.l		#1,16(a5)
	beq		L2Objective1MetAlready
	cmp.l		#5,12(a5)
	bge		L2Objective1Met
	rts
L2Objective1Met:
	move.l		#1,16(a5)
	move.l		#0,20(a5)
L2Objective1MetAlready:
	move.l		20(a5),d1
	move.l		BaseLoc,a0
	move.l		8(a0),d0
	cmp.l		#0,d0
	bge		#L2ObjectiveRight
	move.l		#EndLevelLeft,CurrentBottomText
	move.l		#-1,20(a5)
	bra		L2ObjectiveDone
L2ObjectiveRight
	cmp.l		#(HorizSize-28)*ScreenRatio,d0
	ble		L2ObjectiveNeutral
	move.l		#EndLevelRight,CurrentBottomText
	move.l		#1,20(a5)
	bra		L2ObjectiveDone
L2ObjectiveNeutral:
	move.l		#EndLevel,CurrentBottomText
	move.l		#2,20(a5)
	move.l		HarrLoc,a0
	sub.l		8(a0),d0
	add.l		#(HorizSize/2-8)*ScreenRatio,d0
	cmp.l		#(HorizSize/2-12)*ScreenRatio,d0
	bgt		L2ObjectiveDone
	cmp.l		#(HorizSize/2-32)*ScreenRatio,d0
	blt		L2ObjectiveDone
	move.l		HarrLoc,a0
	move.l		12(a0),d0
	cmp.l		#(ScreenBottom-7)*ScreenVertRatio,d0
	bne		L2ObjectiveDone
	move.l		#LevelDone,CurrentBottomText
	move.l		#3,20(a5)
	move.l		#1,40(a5)
L2ObjectiveDone:
	cmp.l		20(a5),d1
	bne		RefreshBottom
L2ObjectiveMet:
	rts

L2_StartLevelScript:
	move.l		ObjectiveLoc,a0
	move.l		16(a0),d0
	cmp.l		#1,16(a0)
	beq		LevelLoop
	
	jsr		ClearScreenCommon	
	jsr		ClearScreenCommon
	move.l		#Plus,CurrentBottomText

	move.l		#'0',d0
	move.l		ObjectiveLoc,a0
	add.l		12(a0),d0
	move.b		d0,L2Text_3+18
	
	Text		#HorizSize/2-7*3,#VertSize/2-8*3/2,#L2Text_1,#1
	Text		#HorizSize/2-17*3,#VertSize/2-8*1/2,#L2Text_2,#1
	Text		#HorizSize/2-19*3,#VertSize/2+8*1/2,#L2Text_3,#1
	Text		#HorizSize/2-21*3,#VertSize/2+8*3/2,#AcceptText,#1


	jsr		RefreshBottom	;Refresh the bottom line
	jsr		RefreshTop	;Refresh the top line
	jsr		ClearScreenTop2

L2NotAcceptYet
	KeyTest		L2
	Key		0,6,_exit_noheap
	NotKey		0,1,L2NotAcceptYet

	move.l		#Plus,CurrentBottomText
	jsr		RefreshBottom	;Refresh the bottom line
	jsr		ClearScreenCommon
 
	rts