SwapCls	MACRO
;	move.w		#$2EE,d1
;	move.w		#$2B1,d1
	move.w		#(ScreenBottom-ScreenTop)*30/4-1,d1
	move.l		\1,a0
	move.l		\2,a1
	move.l		Screen+4,a2
	move.l		Screen+8,a3
	adda.l		#30*ScreenTop,a0
	adda.l		#30*ScreenTop,a1
	adda.l		#30*ScreenTop,a2
	adda.l		#30*ScreenTop,a3
Swap\3_Loop:
	move.l		(a0),(a1)+
	move.l		#$0,(a0)+
	move.l		#$0,(a2)+
	move.l		#$0,(a3)+
	dbra.w		d1,Swap\3_Loop
	ENDM

KeyTest MACRO
	move.l		#KeyData,a0
	move.w		#$FFFE,d0
	move.w		#6,d1
Key\1_Loop
	move.w		d0,$600018
	nop
	nop
	nop
	nop
	nop
	nop
	nop
	nop
	rol.w		#1,d0
	move.b		$60001B,(a0)+
	dbra.w		d1,Key\1_Loop
	ENDM

NotKey	MACRO
	btst	#\1,(KeyData+\2)
	bne	\3
	ENDM

Key	MACRO
	btst	#\1,(KeyData+\2)
	beq	\3
	ENDM


shiplocmac	MACRO
	move.l		\1,d0
	cmp.l		#ScreenMax,d0
	ble		nottoofar\2
	sub.l		#ScreenSize,d0
nottoofar\2:
	cmp.l		#ScreenMin,d0
	bge		nottoofar2\2
	add.l		#ScreenSize,d0
nottoofar2\2:
	move.l		d0,\1
	ENDM

initobj	MACRO
	move.l		Stack,a6
	move.l		#0,Objs
	ENDM

addnop	MACRO
	lea		-44(a6),a6
	add.l		#1,Objs
	move.l		#NopExe,(a6)
	move.l		#NopExe,4(a6)
	move.l		#-50,8(a6)
	ENDM

addobj	MACRO
	move.l		\14,-(a6)	;40(a6) when can launch object
	move.b		\13,-(a6)	;39(a6)	good/bad
		;(dc.b %0000ABCD.l A=bad can kill it, B=can kill bad,
		;C=good can kill it, D=can kill good)
	move.b		\12,-(a6)	;38(a6)	damage it handles
	move.b		\11,-(a6)	;37(a6)	currobject
	move.b		\10,-(a6)	;36(a6)	numofobjects
	lea		-4(a6),a6	;32(a6)	maskimage
	move.l		#\8,-(a6)	;28(a6)	ltimage
	move.l		#\7,-(a6)	;24(a6)	dkimage
	move.l		\6,-(a6)	;20(a6)	ychg
	move.l		\5,-(a6)	;16(a6)	xchg
	move.l		\4,-(a6)	;12(a6)	y
	move.l		\3,-(a6)	;8(a6)	x
	move.l		#\2,-(a6)	;4(a6)	CrashRun
	move.l		#\1,-(a6)	;(a6)	ExeStart
	add.l		#1,Objs
	ENDM

findobj	MACRO
	move.l		\1,d0
	move.l		a6,a5
	mulu		#11,d0
	add.l		d0,a5
	ENDM

clrobj	MACRO
	move.l		#NopExe,(a5)
	move.l		#NopExe,4(a5)
	move.l		#-50*ScreenRatio,8(a5)
	ENDM

setobj	MACRO
	move.l		#\1,(a5)
	move.l		#\2,4(a5)
	move.l		\3,8(a5)
	move.l		\4,12(a5)
	move.l		\5,16(a5)
	move.l		\6,20(a5)
	move.l		#\7,24(a5)
	move.l		#\8,28(a5)
	move.b		\10,36(a5)
	move.b		\11,37(a5)
	move.b		\12,38(a5)
	move.b		\13,39(a5)
	move.l		\14,40(a5)
	ENDM

Text	MACRO
	move.w		\4,-(sp)
	move.l		\3,-(sp)
	move.w		\2,-(sp)
	move.w		\1,-(sp)
	jsr		tios::DrawStrXY
	adda		#10,sp
	ENDM

NoKeyYet2:
;	KeyTest		15
;	Key		4,0,NoKeyYet2
NKY2\1
	KeyTest		16
	NotKey		4,0,NKY2\1
	rts

ClearScreenCommon:
	SwapCls		Screen,#$4c00,ClearScreen
	rts