NopExe:
	rts

Harrier:

	KeyTest		1

	jsr		Contrast

	NotKey		4,0,NoKey2nd
	move.b		JumpKeys,d0
	cmp.b		#0,d0
	bne		AlreadyPressed2nd
	jsr		InitHarrMissile
	move.b		#$2,JumpKeys
	bra		Harr_EO2nd
AlreadyPressed2nd:
	tst.l		rotate
	bne		Harr_EO2nd
	sub.b		#1,JumpKeys
	bra		Harr_EO2nd
NoKey2nd:
	move.b		#0,JumpKeys
Harr_EO2nd:

	NotKey		3,0,NoKeyRight
	move.b		JumpKeys+2,d0
	cmp.b		#0,d0
	bne		AlreadyPressedRight
	cmp.l		#18,16(a5)
	bge		Harr_EORight
	add.l		#4,16(a5)
	move.b		#$1,JumpKeys+2
	bra		Harr_EORight
AlreadyPressedRight:
	tst.l		rotate
	bne		Harr_EORight
NoKeyRight:
	move.b		#0,JumpKeys+2
Harr_EORight:

	NotKey		2,0,NoKeyDown
	move.b		JumpKeys+4,d0
	cmp.b		#0,d0
	bne		AlreadyPressedDown
	cmp.l		#ScreenVertRatio*7/5,20(a5)
	bge		Harr_EODown
	add.l		#ScreenVertRatio*1/5,20(a5)
	move.b		#$1,JumpKeys+4
	bra		Harr_EODown
AlreadyPressedDown:
	tst.l		rotate
	bne		Harr_EODown
NoKeyDown:
	move.b		#0,JumpKeys+4
Harr_EODown:

	NotKey		1,0,NoKeyLeft
	move.b		JumpKeys+6,d0
	cmp.b		#0,d0
	bne		AlreadyPressedLeft
	cmp.l		#-18,16(a5)
	ble		Harr_EOLeft
	sub.l		#4,16(a5)
	move.b		#$1,JumpKeys+6
	bra		Harr_EOLeft
AlreadyPressedLeft:
	tst.l		rotate
	bne		Harr_EOLeft
NoKeyLeft:
	move.b		#0,JumpKeys+6
Harr_EOLeft:

	NotKey		0,0,NoKeyUp
	move.b		JumpKeys+8,d0
	cmp.b		#0,d0
	bne		AlreadyPressedUp
	cmp.l		#-ScreenVertRatio*7/5,20(a5)
	ble		Harr_EOUp
	sub.l		#ScreenVertRatio*1/5,20(a5)
	move.b		#$1,JumpKeys+8
	bra		Harr_EOUp
AlreadyPressedUp:
	tst.l		rotate
	bne		Harr_EOUp
NoKeyUp:
	move.b		#0,JumpKeys+8
Harr_EOUp:

	cmp.l		#0,16(a5)
	bge		HarrNotLess
	move.l		#HarrLDk,24(a5)
	move.l		#HarrLLt,28(a5)
HarrNotLess:
	cmp.l		#0,16(a5)
	ble		HarrNotGreater
	move.l		#HarrRDk,24(a5)
	move.l		#HarrRLt,28(a5)
HarrNotGreater:
	move.l		16(a5),d1	;change x position
	add.l		d1,Harrier_Horiz
	move.l		Harrier_Horiz,d0
	jsr		shiploc
	move.l		d0,Harrier_Horiz

	divu		#2,d1
	sub.w		d1,10(a5)
	move.l		8(a5),d1
	cmp.l		#(HorizSize/2-8-24)*ScreenRatio,d1
	blt		HarrSetMinX
	cmp.l		#(HorizSize/2-8+24)*ScreenRatio,d1
	bgt		HarrSetMaxX
	bra		HarrXLimitsFine
HarrSetMinX:
	move.l		#(HorizSize/2-8-24)*ScreenRatio,8(a5)
	bra		HarrXLimitsFine
HarrSetMaxX:
	move.l		#(HorizSize/2-8+24)*ScreenRatio,8(a5)
HarrXLimitsFine:
	move.l		20(a5),d0
	add.l		d0,12(a5)
	move.l		12(a5),d0
	cmp.l		#ScreenTop*ScreenVertRatio,d0
	ble		HarrTooHigh
	cmp.l		#(ScreenBottom-7)*ScreenVertRatio,d0
	bge		HarrTooLow
	bra		HarrNotTooHighOrLow
HarrTooHigh
	move.l		#ScreenTop*ScreenVertRatio,12(a5)
	move.l		#0,20(a5)
	bra		HarrNotTooHighOrLow
HarrTooLow
	move.l		#(ScreenBottom-7)*ScreenVertRatio,12(a5)
	move.l		#0,20(a5)
HarrNotTooHighOrLow
	jmp		PicDraw
;	jsr		PicDraw
;	rts

;	40=vertical fall rate?
Projectile:
	move.l		HarrLoc,a0
	move.l		16(a5),d0
	sub.l		16(a0),d0
	add.l		d0,8(a5)
	move.l		40(a5),d0
;	move.l		#1,d0
	add.l		d0,20(a5)
	move.l		20(a5),d0
	add.l		d0,12(a5)
	move.l		8(a5),d0
	jsr		shiploc
	move.l		d0,8(a5)

	move.l		24(a5),a0
	move.w		2(a0),d1
	move.w		#ScreenBottom,d0
	sub.w		d1,d0
	mulu.w		#ScreenVertRatio,d0

;	move.l		#ScreenBottom*ScreenVertRatio,d0
	cmp.l		12(a5),d0
	ble		ProjectileNotAirbound
	cmp.l		#0,12(a5)

	blt		ProjectileTooHigh


;	blt		ProjectileNotAirbound
	bra		ProjectileAirbound
ProjectileNotAirbound
;	move.l		24(a5),a0
;	move.w		(a0),d0
;	divu		#2,d0
;	mulu		#ScreenRatio,d0
;	sub.w		d0,8(a5)
;	sub.l		#8*ScreenRatio,8(a5)
	move.l		4(a5),a0
	jsr		(a0)
ProjectileAirbound:
	jmp		PicDraw

ProjectileTooHigh
	jmp		Hit


MiniJet:
	move.l		HarrLoc,a0
	move.l		16(a5),d0	;change x position
	sub.l		16(a0),d0
	add.l		d0,8(a5)
	move.l		8(a5),d0
	jsr		shiploc
	move.l		d0,8(a5)
	cmp.l		#-16*ScreenRatio,8(a5)	;is image on screen?
	ble		MiniSkipDraw
	cmp.l		#HorizSize*ScreenRatio,8(a5)
	bge		MiniSkipDraw

Mini_DiamondInsert

	move.l		(a0),d0
	cmp.l		#DeadHarrier,d0
	beq		MiniSkip

	move.l		12(a5),d0
	sub.l		12(a0),d0
	cmp.l		#0,d0
	beq		MiniSkip
	ble		MiniLow
	sub.l		#ScreenVertRatio*8/5,12(a5)
MiniLow:
	add.l		#ScreenVertRatio*4/5,12(a5)
	move.l		12(a5),d0
	cmp.l		#ScreenTop*ScreenVertRatio,d0
	blt		MiniTooHigh
	cmp.l		#ScreenBottom*ScreenVertRatio,d0
	blt		MiniSkip
	move.l		#ScreenBottom*ScreenVertRatio,12(a5)
	bra		MiniSkip
MiniTooHigh
	move.l		#ScreenTop*ScreenVertRatio,d0
MiniSkip:
	jmp		PicDraw
;	jsr		PicDraw
MiniSkipDraw:
	rts

StillObj:
	move.l		HarrLoc,a0
	move.l		16(a0),d0
	sub.l		d0,8(a5)
	move.l		8(a5),d0
	jsr		shiploc
	move.l		d0,8(a5)
	jmp		PicDraw

Bomber:
	move.l		HarrLoc,a0
	move.l		16(a5),d0
	sub.l		16(a0),d0
	add.l		d0,8(a5)
	move.l		8(a5),d0
	jsr		shiploc
	move.l		d0,8(a5)


	tst.l		rotate
	bne		BomberNoFireYet
	move.l		40(a5),d0
	sub.l		#1,d0
	move.l		d0,40(a5)
	cmp.l		#0,d0
	bgt		BomberNoFireYet
	move.l		#16,d0
	jsr		random
	add.l		#1,d0
	move.l		d0,40(a5)

	jsr		InitBomb
BomberNoFireYet
	jmp		PicDraw

Tank:
	move.l		HarrLoc,a0
	move.l		16(a5),d0
	sub.l		16(a0),d0
	add.l		d0,8(a5)
	move.l		8(a5),d0
	jsr		shiploc
	move.l		d0,8(a5)

	tst.l		rotate
	bne		TankNoFireYet
	move.l		40(a5),d0
	sub.l		#1,d0
	move.l		d0,40(a5)
	cmp.l		#0,d0
	bgt		TankNoFireYet
	move.l		#16,d0
	jsr		random
	add.l		#1,d0
	move.l		d0,40(a5)

	jsr		InitTankMissile	
TankNoFireYet
	jmp		PicDraw

LavaSpitter:
	move.l		HarrLoc,a0
	move.l		16(a0),d0
	sub.l		d0,8(a5)
	move.l		8(a5),d0
	jsr		shiploc
	move.l		d0,8(a5)

	tst.l		rotate
	bne		LavaSpitterNoFireYet
	move.l		40(a5),d0
	sub.l		#1,d0
	move.l		d0,40(a5)
	cmp.l		#0,d0
	bgt		LavaSpitterNoFireYet
	move.l		#20,d0
	jsr		random
	add.l		#1,d0
	move.l		d0,40(a5)

	jsr		InitLavaSpit
LavaSpitterNoFireYet
	jmp		PicDraw

RocketTower:
	move.l		HarrLoc,a0
	move.l		16(a0),d0
	sub.l		d0,8(a5)
	move.l		8(a5),d0
	jsr		shiploc
	move.l		d0,8(a5)

	tst.l		rotate
	bne		RocketTowerNoFireYet
	move.l		40(a5),d0
	sub.l		#1,d0
	move.l		d0,40(a5)
	cmp.l		#0,d0
	bgt		RocketTowerNoFireYet
	move.l		#20,d0
	jsr		random
	add.l		#1,d0
	move.l		d0,40(a5)

	jsr		InitRocket
RocketTowerNoFireYet
	jmp		PicDraw


Explode:
	tst.l		CurrScreenNum
	beq		ExplodeNoNewImage
	add.b		#1,37(a5)
	move.l		#0,d0
	move.b		37(a5),d0
	muls.w		#4,d0
	move.l		#ExplodeTable,a0
	move.l		0(a0,d0),d1
	move.l		d1,24(a5)
	move.l		d1,28(a5)
	cmp		#20,d0
	bne		ExplodeNoNewImage
	clrobj
	rts
ExplodeNoNewImage:
	move.l		8(a5),d0
	jsr		shiploc
	move.l		d0,8(a5)
	move.l		16(a5),d0
	add.l		d0,8(a5)
	jmp		PicDraw

NukeExplode:		;need to slow down rate of explode
	tst.l		CurrScreenNum
	beq		NukeExplodeNoNewImage
	add.b		#1,37(a5)
	move.l		#0,d0
	move.b		37(a5),d0
	muls.w		#4,d0
	move.l		#NukeExplodeTable,a0
	move.l		0(a0,d0),d1
	move.l		d1,24(a5)
	move.l		d1,28(a5)
	cmp		#20,d0
	bne		NukeExplodeNoNewImage
	clrobj
	rts
NukeExplodeNoNewImage:
	move.l		8(a5),d0
	jsr		shiploc
	move.l		d0,8(a5)
	move.l		HarrLoc,a0
	move.l		16(a0),d0
	sub.l		d0,8(a5)
	jmp		PicDraw


Hit:
	clrobj
	rts

HarrHit:

	jsr		ClearScreenCommon

;	jsr		OneLessLife
	move.b		#'0',d0
	cmp.b		Lives+9,d0
	bne		HarrHitButNotDead

	jsr		HighScoreRoutine
DeadMeat:
	KeyTest		Enter
	NotKey		0,1,DeadMeat
	jmp		_exit_noheap

HarrHitButNotDead:
	move.l		Harrier_Horiz,d0
	sub.l		16(a5),d0
	move.l		a6,a4
;	move.l		Objs,d4
;	sub.l		#1,d4
HarrHitLoop:
	cmp.l		#Level1Objectives,(a4)
	beq		DontMoveLoc
	cmp.l		#Level2Objectives,(a4)
	beq		DontMoveLoc
;	cmp.l		#Level3Objectives,(a4)
;	beq		DontMoveLoc
	cmp.l		#NopExe,(a4)
	beq		DontMoveLoc
	add.l		d0,8(a4)
DontMoveLoc
	add.l		#44,a4
	cmp.l		a4,a5
	bne		HarrHitLoop
;	dbra.w		d4,HarrHitLoop

	move.b		#%1000,39(a5)
	move.l		#Harrier,(a5)
	move.l		#InitDeadHarrier,4(a5)


	move.b		#1,38(a5)
	move.l		#0,Harrier_Horiz
	move.l		#(HorizSize/2-8)*ScreenRatio,8(a5)
	move.l		#(ScreenBottom-7)*ScreenVertRatio,12(a5)
	move.l		#0,16(a5)
	move.l		#0,20(a5)

	move.l		CurrLevelStartScript,a0
	jsr		(a0)
	jmp		RefrLevl

Skull:
	move.l		HarrLoc,a0

	move.l		16(a5),d0
	sub.l		16(a0),d0
	add.l		d0,8(a5)
	move.l		8(a5),d0
	jsr		shiploc
	move.l		d0,8(a5)

	move.l		20(a5),d0
	add.l		d0,12(a5)
	add.l		#1,20(a5)

	move.l		#0,d0
	move.l		24(a5),a0
	move.w		2(a0),d0
	muls		#ScreenVertRatio,d0
	move.l		#ScreenBottom*ScreenVertRatio,d1
	sub.l		d0,d1

	cmp.l		12(a5),d1
	bgt		SkullEndObj

	move.l		d1,12(a5)

	move.l		#45,d0
	jsr		random
	add.l		#30,d0

	move.l		#0,20(a5)
	sub.l		d0,20(a5)

	move.l		#75,d1
	sub.l		d0,d1
	
	divu		#3,d1
	swap		d1
	move.w		#0,d1
	swap		d1
	move.l		d1,16(a5)

	divu		#2,d0
	swap		d0
	tst.w		d0
	beq		SkullLeft
	move.l		d1,16(a5)
	bra		SkullEndObj
SkullLeft
	move.l		#0,16(a5)
	sub.l		d1,16(a5)
SkullEndObj
	move.l		#0,d0
	move.b		38(a5),d0
	mulu		#8,d0
	move.l		#SkullTable-8,a0
	add.l		d0,a0
	move.l		4(a0),24(a5)
	move.l		(a0),28(a5)

	move.l		ObjectiveLoc,a0
	move.l		20(a0),d1

	move.l		8(a5),d0
	cmp.l		#0,d0
	bge		#SkullRightofYou
	move.l		#ObjectLeft,CurrentBottomText
	move.l		#-1,20(a0)
	bra		SkullDone
SkullRightofYou
	cmp.l		#(HorizSize-17)*ScreenRatio,d0
	ble		SkullNeutralofYou
	move.l		#ObjectRight,CurrentBottomText
	move.l		#1,20(a0)
	bra		SkullDone
SkullNeutralofYou:
	move.l		#Plus,CurrentBottomText
	move.l		#2,20(a0)
SkullDone
	cmp.l		20(a0),d1
	bne		SkullTextNotChange
	jsr		RefreshBottom
SkullTextNotChange

	tst.l		rotate
	bne		SkullNoFireYet

	cmp.l		#-17*ScreenRatio,8(a5)	;is image on screen?
	ble		MiniSkipDraw
	cmp.l		#HorizSize*ScreenRatio,8(a5)
	bge		MiniSkipDraw

	move.l		40(a5),d0
	sub.l		#1,d0
	move.l		d0,40(a5)
	cmp.l		#0,d0
	bgt		SkullNoFireYet
	move.l		#32,d0
	jsr		random
	add.l		#1,d0
	move.l		d0,40(a5)
	jsr		InitDiamond
SkullNoFireYet
	jmp		PicDraw

SkullTable
	dc.l		Skull5Lt
	dc.l		Skull5Dk
	dc.l		Skull4Lt
	dc.l		Skull4Dk
	dc.l		Skull3Lt
	dc.l		Skull3Dk
	dc.l		Skull2Lt
	dc.l		Skull2Dk
	dc.l		Skull1Lt
	dc.l		Skull1Dk

Diamond:
	move.l		HarrLoc,a0

	move.l		16(a0),d0
	sub.l		d0,8(a5)
	move.l		8(a5),d0
	jsr		shiploc
	move.l		d0,8(a5)
	
	tst		CurrScreenNum
	bne		Diamond_NotScreen1
	add.l		#1,40(a5)
	move.l		40(a5),d0
	cmp.l		#8,d0
	blt		Diamond_DontCycle
	move.l		#0,d0
	move.l		d0,40(a5)
Diamond_DontCycle
	muls		#4,d0
	add.l		#DiamondTable,d0
	move.l		d0,a0
	move.l		(a0),24(a5)
	move.l		(a0),28(a5)
Diamond_NotScreen1


	cmp.l		#-5*ScreenRatio,8(a5)	;is image on screen?
	ble		DiamondSkipDraw
	cmp.l		#HorizSize*ScreenRatio,8(a5)
	bge		DiamondSkipDraw

	move.l		HarrLoc,a0
	move.l		(a0),d0
	cmp.l		#DeadHarrier,d0
	beq		DiamondSkip
	move.l		12(a5),d0
	sub.l		12(a0),d0
	cmp.l		#0,d0
	beq		DiamondSkip
	ble		DiamondLow
	sub.l		#ScreenVertRatio*4/3,12(a5)
DiamondLow:
	add.l		#ScreenVertRatio*2/3,12(a5)
	move.l		12(a5),d0
	cmp.l		#ScreenTop*ScreenVertRatio,d0
	blt		DiamondTooHigh
	cmp.l		#ScreenBottom*ScreenVertRatio,d0
	blt		DiamondSkip
	move.l		#ScreenBottom*ScreenVertRatio,12(a5)
	bra		DiamondSkip
DiamondTooHigh
	move.l		#ScreenTop*ScreenVertRatio,d0
DiamondSkip:

	jmp		PicDraw
DiamondSkipDraw:
	rts


Alien:
	move.l		HarrLoc,a0
	move.l		16(a5),d0
	sub.l		16(a0),d0
	add.l		d0,8(a5)
	move.l		8(a5),d0
	jsr		shiploc
	move.l		d0,8(a5)

	tst.l		rotate
	bne		AlienNoFireYet

	move.l		40(a5),d0
	sub.l		#1,d0
	move.l		d0,40(a5)
	cmp.l		#0,d0
	bgt		AlienNoFireYet
	move.l		#16,d0
	jsr		random
	add.l		#16,d0
	move.l		d0,40(a5)

	jsr		InitAlienMissile	
AlienNoFireYet

	move.l		12(a5),d0
	cmp.l		#ScreenVertRatio*(ScreenBottom-7),d0
	blt		AlienIsJumping

	tst.l		rotate
	bne		Alien_DontSwitchPic

	move.l		24(a5),d0

	cmp.l		#AlienL1Dk,d0
	bne		AlienL1Dk_Not
	move.l		#AlienL2Dk,24(a5)
	move.l		#AlienL2Dk,28(a5)
	bra		Alien_DontSwitchPic
AlienL1Dk_Not:
	cmp.l		#AlienR1Dk,d0
	bne		AlienR1Dk_Not
	move.l		#AlienR2Dk,24(a5)
	move.l		#AlienR2Dk,28(a5)
	bra		Alien_DontSwitchPic
AlienR1Dk_Not:

	cmp.l		#AlienL2Dk,d0
	bne		AlienL2Dk_Not
	move.l		#AlienL1Dk,24(a5)
	move.l		#AlienL1Dk,28(a5)
	bra		Alien_DontSwitchPic
AlienL2Dk_Not:
	cmp.l		#AlienR2Dk,d0
	bne		AlienR2Dk_Not
	move.l		#AlienR1Dk,24(a5)
	move.l		#AlienR1Dk,28(a5)
	bra		Alien_DontSwitchPic
AlienR2Dk_Not:

Alien_DontSwitchPic
	move.l		20(a5),d0
	cmp.l		#0,d0
	beq		AlienJumpYet
	move.l		#ScreenVertRatio*(ScreenBottom-7),12(a5)
	move.l		#0,20(a5)
	move.l		#16,d0
	jsr		random
	add.l		#16,d0
	move.l		d0,32(a5)
	bra		AlienJumpDone

AlienJumpYet
	tst.l		rotate
	bne		AlienJumpDone
	move.l		#-1,d0
	add.l		d0,32(a5)
	move.l		32(a5),d0
	cmp.l		#0,d0
	bgt		AlienJumpDone
	
	move.l		#50,d0
	jsr		random
	sub.l		#85,d0
	move.l		d0,20(a5)

	move.l		24(a5),d0

	cmp.l		#AlienL1Dk,d0
	bne		AlienL1Dk_Not2
	move.l		#AlienL2Dk,24(a5)
	move.l		#AlienL2Dk,28(a5)
	bra		AlienIsJumping
AlienL1Dk_Not2:
	cmp.l		#AlienR1Dk,d0
	bne		AlienR1Dk_Not2
	move.l		#AlienR2Dk,24(a5)
	move.l		#AlienR2Dk,28(a5)
	bra		AlienIsJumping
AlienR1Dk_Not2:




AlienIsJumping
	move.l		20(a5),d0
	add.l		#1,d0
	move.l		d0,20(a5)
	add.l		d0,12(a5)

AlienJumpDone
	jmp		PicDraw

DiamondTable
	dc.l		Diamond1
	dc.l		Diamond2
	dc.l		Diamond3
	dc.l		Diamond4
	dc.l		Diamond4
	dc.l		Diamond3
	dc.l		Diamond2
	dc.l		Diamond1
