Level3:
;	jsr		ResetGame
	initobj
	jsr		InitHarrier
	move.l		HarrLoc,a5
	move.l		#0,JumpKeys	;clear the codes for the "Jump Keys"
	move.l		#0,JumpKeys+4

	move.l		#7,d0
	jsr		InitRocketTower

	move.l		#10,d0
	jsr		InitAlien

	jsr		InitSkull

	jsr		InitBase

	addobj		Level1Objectives,NopExe,#-50*ScreenRatio,#2,#0,#0,0,0,#0,#0,#0,#0,#0,#0

	move.l		a6,ObjectiveLoc

	move.l		LevelNum,d0
	Swap		d0
	cmp.w		#1,d0
	bne		L3_NotNewGame
	jsr		ResetGame
L3_NotNewGame:
	;clear the screen

	move.l		#Plus,CurrentBottomText

	move.l		#L3_StartLevelScript,CurrLevelStartScript
	move.l		CurrLevelStartScript,a0
	jmp		(a0)
;	rts

;Level3Objectives:
;	move.l		#-50*ScreenRatio,8(a5)
;	cmp.l		#1,24(a5)
;	beq		L3ObjectiveMet
;	cmp.l		#1,16(a5)
;	beq		L3Objective1MetAlready
;	cmp.l		#1,12(a5)
;	bge		L3Objective1Met
;	rts	
;L3Objective1Met:
;	move.l		#1,16(a5)
;	move.l		#0,20(a5)
;L3Objective1MetAlready:
;	move.l		20(a5),d1
;	move.l		BaseLoc,a0
;	move.l		8(a0),d0
;	cmp.l		#0,d0
;	bge		#L3ObjectiveRight
;	move.l		#EndLevelLeft,CurrentBottomText
;	move.l		#-1,20(a5)
;	bra		L3ObjectiveDone
;L3ObjectiveRight
;	cmp.l		#(HorizSize-28)*ScreenRatio,d0
;	ble		L3ObjectiveNeutral
;	move.l		#EndLevelRight,CurrentBottomText
;	move.l		#1,20(a5)
;	bra		L3ObjectiveDone
;L3ObjectiveNeutral:
;	move.l		#EndLevel,CurrentBottomText
;	move.l		#2,20(a5)
;
;	move.l		HarrLoc,a0
;	sub.l		8(a0),d0
;	add.l		#(HorizSize/2-8)*ScreenRatio,d0
;
;
;	cmp.l		#(HorizSize/2-12)*ScreenRatio,d0
;
;	bgt		L3ObjectiveDone
;
;	cmp.l		#(HorizSize/2-32)*ScreenRatio,d0
;
;	blt		L3ObjectiveDone
;	move.l		HarrLoc,a0
;	move.l		12(a0),d0
;	cmp.l		#(ScreenBottom-7)*ScreenVertRatio,d0
;	bne		L3ObjectiveDone
;	move.l		#LevelDone,CurrentBottomText
;	move.l		#3,20(a5)
;	move.l		#1,40(a5)
;L3ObjectiveDone:
;	cmp.l		20(a5),d1
;	bne		RefreshBottom
;L3ObjectiveMet:
;	rts

L3_StartLevelScript:
	move.l		ObjectiveLoc,a0
	move.l		16(a0),d0
	cmp.l		#1,16(a0)
	beq		LevelLoop
	
	jsr		ClearScreenCommon	
	jsr		ClearScreenCommon
	move.l		#Plus,CurrentBottomText

;	move.l		#'0',d0
;	move.l		ObjectiveLoc,a0
;	add.l		12(a0),d0
;	move.b		d0,L3Text_3+18
	
	Text		#HorizSize/2-7*3,#VertSize/2-8*3/2,#L3Text_1,#1
	Text		#HorizSize/2-24*3,#VertSize/2-8*1/2,#L3Text_2,#1

	Text		#HorizSize/2-21*3,#VertSize/2+8*3/2,#AcceptText,#1

	jsr		RefreshBottom	;Refresh the bottom line
	jsr		RefreshTop	;Refresh the top line
	jsr		ClearScreenTop2

L3NotAcceptYet
	KeyTest		L3
	Key		0,6,_exit_noheap
	NotKey		0,1,L3NotAcceptYet

	move.l		#Plus,CurrentBottomText
	jsr		RefreshBottom	;Refresh the bottom line
	jsr		ClearScreenCommon
 
	rts