PicDraw:
	cmp.l		#-50*ScreenRatio,8(a5)
	ble		SkipPicDraw
	cmp.l		#160*ScreenRatio,8(a5)
	bge		SkipPicDraw
	cmp.l		#(ScreenTop-16)*ScreenVertRatio,12(a5)
	ble		SkipPicDraw
	cmp.l		#ScreenBottom*ScreenVertRatio,12(a5)
	bge		SkipPicDraw
	move.l		12(a5),d0
	divs		#ScreenVertRatio,d0
	and.l		#$0000FFFF,d0
	muls		#240,d0				;D0=Y*240
	move.l		8(a5),d1
	add.l		#ScreenRatio*50,d1
	divs		#ScreenRatio,d1
	and.l		#$0000FFFF,d1
	sub.l		#50,d1				;D1=X
	add.l		d1,d0				;D0=Y*240+X		
	move.l		Screen,d6			;D6=SCREEN1
	move.l		24(a5),a2			;A2=IMAGEDK
	move.l		28(a5),a3			;A3=IMAGELT
	move.l		a2,a0				;A0=IMAGEDK
	cmp.l		#0,CurrScreenNum
	bne		PicSkipLt			;IF NOT DARK
	move.l		a3,a0				;A0=IMAGELT
PicSkipLt:
	move.b		d0,d2				;D2=Y*240+X+1920
	and.l		#$F,d2				;D2=WORD SHIFT AMT
	and.l		#$FFFFFFF0,d0			
	lsr		#3,d0				;D0=STARTING WORD OFFFSET
	add.l		d0,d6				;D6=PICTURE STARTING WORD
	move.w		(a2)+,d0			;D0=IMAGE X(# OF WORDS/LINE)
	move.w		(a2)+,d1			;D1=IMAGE Y(# OF LINES)
	lea		4(a3),a3			;A2,A3,A0=START OF IMAGE
	lea		4(a0),a0
	sub.w		#1,d0				;D0 AND D1 SET FOR DBcc ROUTINE
	sub.w		#1,d1
	move.l		Screen+4,d3
	sub.l		Screen,d3			;D3=(SCREEN+4)-(SCREEN)
	btst		#0,39(a5)
	bne		PicBad
	btst		#2,39(a5)
	bne		PicGood

	move.l		Screen,a2
	add.l		d6,a2
	move.l		a2,a3				;A2,A3=BLANK IMAGES
	bra		PicVert
PicBad:
	move.l		Screen+8,d3			;D3=(SCREEN+8)-(SCREEN)
	sub.l		Screen,d3
	bra		PicVert
PicGood:
PicVert:
	move.l		d6,a1				;A1=STARTING LOC ON LONE
	add.l		#30,d6				;D6 ADVANCED TO NEXT LINE
	move.w		d0,d4				;D4=NUM OF TIMES PER LINE
PicHoriz:
	clr.l		d5
	move.w		(a0)+,d5
	swap		d5
	ror.l		d2,d5
	eor.l		d5,(a1)

	clr.l		d5
	move.w		(a2)+,d5
	or.w		(a3)+,d5
	swap		d5
	ror.l		d2,d5
	or.l		d5,0(a1,d3)

	lea		2(a1),a1
	dbra.w		d4,PicHoriz
	dbra.w		d1,PicVert
SkipPicDraw:
	rts


CrashTest:
	cmp.l		#-50*ScreenRatio,8(a5)
	ble		SkipCrash
	cmp.l		#160*ScreenRatio,8(a5)
	bge		SkipCrash
	cmp.l		#(ScreenTop-16)*ScreenVertRatio,12(a5)
	ble		SkipCrash
	cmp.l		#ScreenBottom*ScreenVertRatio,12(a5)
	bgt		SkipCrash

	move.l		12(a5),d0
	divs		#ScreenVertRatio,d0
	and.l		#$0000FFFF,d0
	muls		#240,d0

	move.l		8(a5),d1
	add.l		#ScreenRatio*50,d1
	divs		#ScreenRatio,d1
	and.l		#$0000FFFF,d1
	sub.l		#50,d1
	add.l		d1,d0

	move.l		Screen+8,a0
	btst		#1,39(a5)
	bne		CrashBadGuy
	btst		#3,39(a5)
	bne		CrashGood
	bra		SkipCrash
CrashBadGuy:
	move.l		Screen+4,a0
CrashGood:

	move.l		24(a5),a2
	move.l		28(a5),a3
	move.b		d0,d2
	and.l		#$F,d2
	and.l		#$FFFFFFF0,d0
	lsr		#3,d0
	add.l		d0,a0
	move.w		(a2)+,d0
	move.w		(a2)+,d1
	lea		4(a3),a3
	sub.w		#1,d0
	sub.w		#1,d1
CrashVert:
	move.l		a0,a1
	add.l		#30,a0
	move.w		d0,d4
CrashHoriz:
	clr.l		d5
	move.w		(a2)+,d5
	or.w		(a3)+,d5
	swap		d5
	ror.l		d2,d5
	and.l		(a1),d5
	lea		2(a1),a1
	cmp.l		#0,d5
	dbne.w		d4,CrashHoriz
	dbne.w		d1,CrashVert
SkipCrash:
	rts

random:
	move.w		rand_seed(pc),d1
	add.w		a7,d1
	mulu.w		#31421,d1
	add.w		#6927,d1
	mulu.w		d1,d0
	move.w		d1,rand_seed
	clr.w		d0
	swap		d0
	rts

shiploc:
	cmp.l		#ScreenMax,d0
	ble		nottoofar
	sub.l		#ScreenSize,d0
nottoofar:
	cmp.l		#ScreenMin,d0
	bge		nottoofar2
	add.l		#ScreenSize,d0
nottoofar2:
	rts


MakeNopObjs:
	move.b		36(a6),d0
	sub.b		#1,d0
MakeNextNopObj:
	lea		-44(a6),a6
	add.l		#1,Objs
	move.l		#NopExe,(a6)
	move.l		#NopExe,4(a6)
	move.l		#-50,8(a6)
	dbra.b		d0,MakeNextNopObj
	rts

InitXtraObj:
	move.l		a5,d0
	clr.l		d1
	move.b		37(a5),d1
	mulu.w		#44,d1
	swap		d1
	move.w		#0,d1
	swap		d1
	sub.l		d1,d0
	move.l		d0,a0
	add.b		#1,37(a5)
	move.b		36(a5),d0
	move.b		37(a5),d1
	cmp.b		d0,d1
	bne		InitXtraDone
	move.b		#1,37(a5)
InitXtraDone:
	rts

;	cmp.l		#NopExe,(a0)
;	beq		InitXtraObjContinue
;	move.l		#-1,d0
;	rts
;InitXtraObjContinue



AddScore:

;	add.b		#1,Score+7

	move.b		d0,d1
	and.l		#$F,d1
	add.b		d1,Score+7
	lsr		#4,d0

	move.b		d0,d1
	and.l		#$F,d1
	add.b		d1,Score+6
	lsr		#4,d0

	move.b		d0,d1
	and.l		#$F,d1
	add.b		d1,Score+5
	lsr		#4,d0

	move.b		d0,d1
	and.l		#$F,d1
	add.b		d1,Score+4
	lsr		#4,d0

	move.b		d0,d1
	and.l		#$F,d1
	add.b		d1,Score+3
	lsr		#4,d0

	move.b		d0,d1
	and.l		#$F,d1
	add.b		d1,Score+2
	lsr		#4,d0

	move.b		d0,d1
	and.l		#$F,d1
	add.b		d1,Score+1
	lsr		#4,d0

	move.b		d0,d1
	and.l		#$F,d1
	add.b		d1,Score

; 	move.b		#6,d1
;	move.l		#Score+7,a0
;AddScoreAddLoop:
;	move.b		d0,d2
;	and.l		#$F,d2
;	add.b		d2,-(a0)
;	lsr		#4,d0
;	dbra.b		d1,AddScoreAddLoop	


	move.b		#6,d1
	move.l		#Score+7,a0
CarryLoop:
	move.b		(a0),d0
	cmp.b		#'9',d0
	ble		NoCarry
	sub.b		#10,(a0)
	add.b		#1,-1(a0)
NoCarry:
	sub.l		#1,a0
	dbra.b		d1,CarryLoop

	bra		RefreshTop

RefreshTop:
	move.w		#$3B,d0
	move.w		#$4c00,a0
ClearTop:
	move.l		#0,(a0)+
	dbra.w		d0,ClearTop

	move.w		#1,-(sp)
	move.l		#Score,-(sp)
	move.w		#0,-(sp)
	move.w		#HorizSize-8*6,-(sp)
	jsr		tios::DrawStrXY
	adda		#10,sp

	move.w		#1,-(sp)
	move.l		#Lives,-(sp)
	move.w		#0,-(sp)
	move.w		#0,-(sp)
	jsr		tios::DrawStrXY
	adda		#10,sp

	rts

OneLessLife:
	sub.b		#1,Lives+9
	
;	move.b		Lives+9,d0
;	cmp.b		#'0',d0
;	bge		UnCarry
;	add.b		#10,Lives+9
;UnCarry:
	bra		RefreshTop

RefreshBottom:
	
	move.l		#$4c00,a0	;Black out bottom and add a plus
	adda.l		#2760,a0
	move.l		#59,d0
BlackOnBottom:
	move.l		#$FFFFFFFF,(a0)+
	dbra.w		d0,BlackOnBottom

	move.l		CurrentBottomText,a0
	move.b		#-1,d0
CheckStrLen:
	add.w		#1,d0
	move.b		(a0)+,d1
	cmp.b		#0,d1
	bne		CheckStrLen

;	move.w		#0,d0
	mulu.w		#3,d0
	sub.w		#HorizSize/2,d0
;	move.w		#HorizSize/2,d0
	move.w		#0,d1
	sub.w		d0,d1

	move.w		#2,-(sp)
	move.l		CurrentBottomText,-(sp)
	move.w		#VertSize-7,-(sp)
;	move.w		#HorizSize/2,-(sp)
	move.w		d1,-(sp)
	jsr		tios::DrawStrXY
	adda		#10,sp
	rts

HighScoreRoutine:
	move.l		#6,d0
	move.l		#Score,a0
	move.l		#HighScore,a1

HSLoop
	move.b		(a0)+,d1
	cmp.b		(a1),d1
	blt		NotHigh
	cmp.b		(a1)+,d1
	bgt		High
	dbra.l		d0,HSLoop
NotHigh:
	rts
High:
	move.l		Score,HighScore
	move.l		Score+4,HighScore+4

	move.w		#2,-(sp)
	move.l		#HighScoreText,-(sp)
	move.w		#VertSize/2,-(sp)
	move.w		#HorizSize/2-13*3,-(sp)
	jsr		tios::DrawStrXY
	adda		#10,sp
	rts

ClearScreenTop:
	move.l		#$4c00,a0
	move.l		Screen+4,a1
	move.l		#ScreenTop*30/4-1,d0
ClearScreenTop_Loop:
	move.l		(a1)+,(a0)+
	dbra.w		d0,ClearScreenTop_Loop
	rts

ClearScreenTop2:
	move.l		Screen+4,a0
	move.l		Screen+8,a1
	move.l		#ScreenTop*30/4-1,d0
ClearScreenTop_Loop2:
	move.l		#0,(a0)+
	move.l		#0,(a1)+
	dbra.w		d0,ClearScreenTop_Loop2
	rts

Contrast:
	tst.l		CurrScreenNum
	bne		NoKeyMinus
	NotKey		1,1,NoKeyPlus
	jsr		tios::OSContrastUp
NoKeyPlus
	NotKey		2,1,NoKeyMinus
	jsr		tios::OSContrastDn
NoKeyMinus
	rts
